%Made by J.T.B. Overvelde on 9 may 2011

function [x, y, xp, yp, u, v, p]=gridInit()
%generate empty cell coordinates, empty velocity matrices and empty
%pressure matrices

global rho mu g dt nX nY nXp nYp w h N hx hy

nYp=nY+1;
nXp=nX;

x=zeros(nX,nY);
y=zeros(nX,nY);
xp=zeros(nXp,nYp);
yp=zeros(nXp,nYp);
u=zeros(nX,nY);
v=zeros(nX,nY);
p=zeros(nX,nY);

for i=1:nX;
    x(i,:)=w*(i-1)/(nX-1);
end

for j=1:nY;
    y(:,j)=h*(j-1)/(nY-1);
end

for i=1:nXp;
    xp(i,:)=w*(i-1.5)/(nXp-1);
end

for j=1:nYp
    yp(:,j)=h*(j-1.5)/(nYp-2);
end

hx = 0.5*(x(3,2)-x(1,2));
hy = 0.5*(y(2,3)-y(2,1));

%plot staggered grid and walls
figure
plot(x,y,'.','color','r','markersize',5), hold on
plot(xp,yp,'*','color','b','markersize',5)
plot([0 0 w-1/2*hx w-1/2*hx 0],[0 h h 0 0],'color','g')

%calculate cell centers for pressure and make cell number matrix
N=zeros(nXp,nYp);
for i=1:nXp
    for j=1:nYp
        N(i,j)=i+(j-1)*nXp;
    end
end

