%Made by J.T.B. Overvelde on 9 may 2011

function render(u,v,p,res,x,y,xp,yp,t,dt,nCycles)
global mu w h hx hy
    clf;
    subplot(2,3,1), surf(x,y,u);title('u velocity'), axis([0 w 0 h]), view(3)
    shading interp;
    subplot(2,3,2), surf(x,y,v);title('v velocity'), axis([0 w 0 h]), view(3)
    shading interp;
    subplot(2,3,3), surf(xp,yp,p);title('pressure'), axis([0 w 0 h]), view(3)    
    shading interp;
    ax4 = subplot(2,3,4),quiver(x,y,u,v), hold on, surf(x,y,(u.^2+v.^2),'FaceAlpha',0.6),shading flat;title('field'), hold on, axis([0 w 0 h]);
%     axis equal
    set(ax4,'CLim',[min(min((u.^2+v.^2))) max(max((u.^2+v.^2)))]);

    lgmax = (max(max((u.^2+v.^2))));
    lgmin = (min(min((u.^2+v.^2))));

    lgsp = linspace(lgmin,lgmax,20).^3/lgmax^2;
    contour(x,y,(u.^2+v.^2),lgsp);

    hold off,axis([0 w 0 h]);
    
    subplot(2,3,5), surf(x,y,res); title(['residual']), axis([0 w 0 h]), view(3)
    shading interp;
    rey = sprintf('max reynolds number Re: %f', max(max(u*max(w,h)/mu)));
    couU = sprintf('max Courant number U: %f', max(max(u*dt/hx)));
    couV = sprintf('max Courant number V: %f', max(max(v*dt/hy)));
    pec = sprintf('max Peclet number: %f', max(max(u*hx/mu)));
    resmax = sprintf('max residual: %f', max(max(abs(res))));
    resavg = sprintf('sum residual: %f', sum(sum(res)));
    prdt = sprintf('dt: %f', dt);
    prt = sprintf('t: %f', t);
    prcycles = sprintf('# Cycles: %f', nCycles);
    uicontrol('Style', 'text', 'String',rey,'Position', [900 200 200 70]);        
    uicontrol('Style', 'text', 'String',couU,'Position', [900 180 200 70]);        
    uicontrol('Style', 'text', 'String',couV,'Position', [900 160 200 70]);        
    uicontrol('Style', 'text', 'String',pec,'Position', [900 140 200 70]);        
    uicontrol('Style', 'text', 'String',resmax,'Position', [900 120 200 70]);        
    uicontrol('Style', 'text', 'String',resavg,'Position', [900 100 200 70]);        
    uicontrol('Style', 'text', 'String',prdt,'Position', [900 80 200 70]);        
    uicontrol('Style', 'text', 'String',prcycles,'Position', [900 60 200 70]);        
    uicontrol('Style', 'text', 'String',prt,'Position', [900 40 200 70]);        
